void setupCP5() {
    cp5 = new ControlP5(this);
    // add toggle for dewey class
    addToggle("toggle_na", "N/A", DEWEY_COLOR[0], 15, height-90);
    for (int i = 1; i < 11; i++) {
        String digit = String.format("%03d", (i - 1) * 100);
        addToggle("toggle_" + digit, digit, DEWEY_COLOR[i], 15 + 20 * i, height-90);
    }
    // add toggle for years
    for (int i = 0; i < years; i++) {
        int year = START_YEAR + i;
        addToggle("toggle_" + String.valueOf(year), String.valueOf(year), YEAR_COLOR, 15 + 20 * i, height-60);
    }
    // add year list for selecting year
    List<String> yearList = new ArrayList();
    for (int i = 0; i < years; i++) {
        yearList.add(String.valueOf(i + START_YEAR));
    }
    yearList.add("AllTime");
    cp5.addScrollableList("handleYear")
        .setPosition(width-15-150, 50)
        .setSize(150, height-100)
        .setBarHeight(20)
        .setItemHeight(20)
        .setType(ControlP5.DROPDOWN)
        .setColorForeground(getSemi(YEAR_COLOR))
        .setColorBackground(getSemi(YEAR_COLOR))
        .setColorActive(YEAR_COLOR)
        .setColorLabel(FONT_COLOR)
        .setLabel("YEAR")
        .setOpen(false)
        .onEnter(new CallbackListener() {
            public void controlEvent(CallbackEvent theEvent) {
                cp5.get(ScrollableList.class, "handleTitle").setOpen(false);
            }
        })
        .addItems(yearList);
    // add title list
    cp5.addScrollableList("handleTitle")
        .setPosition(width-15-150, 80)
        .setSize(150, height-100)
        .setBarHeight(20)
        .setItemHeight(20)
        .setType(ControlP5.LIST)
        .setColorForeground(getSemi(YEAR_COLOR))
        .setColorBackground(getSemi(YEAR_COLOR))
        .setColorActive(YEAR_COLOR)
        .setColorLabel(FONT_COLOR)
        .setLabel("TITLE")
        .setOpen(false);
    // add slider for hover text
    cp5.addSlider("sliderValue")
        .setPosition(15,height-30)
        .setSize(400,20)
        .setHandleSize(5)
        .setDecimalPrecision(1)
        .setColorForeground(getSemi(YEAR_COLOR))
        .setColorBackground(getSemi(YEAR_COLOR))
        .setColorActive(YEAR_COLOR)
        .setColorLabel(FONT_COLOR)
        .setLabel("RECORDS")
        .onEnter(new CallbackListener() {
            public void controlEvent(CallbackEvent theEvent) {
                cam.setLeftDragHandler(null);
            }
        })
        .onLeave(new CallbackListener() {
            public void controlEvent(CallbackEvent theEvent) {
                cam.setLeftDragHandler(singleDragHandler);
            }
        });
    cp5.setAutoDraw(false);
}

void addToggle(String toggle, String dewey, color c, int x, int y) {
    cp5.addToggle(toggle)
        .setPosition(x, y)
        .setColorForeground(getSemi(c))
        .setColorBackground(getSemi(c))
        .setColorActive(c)
        .setColorLabel(FONT_COLOR)
        .setSize(15, 15)
        .setLabel(dewey)
        .setValue(true);
}
