import csv
import sys


def main(filename: str):
    with open(filename, 'r') as fin:
        with open(f'cout_{filename[:-4]}.sql', 'w+') as fout:
            year = filename[6:10]
            csv_reader = csv.DictReader(fin, delimiter=',')
            item_num = ''
            for row in csv_reader:
                item_num += f" OR itemNumber={row['itemNumber']}"
            item_num = item_num[4:]
            fout.write(
                f'SELECT title, itemNumber, cout, cin, itemType, deweyClass\nFROM spl_2016.inraw\nWHERE ({item_num}) AND YEAR(cout)={year}\nGROUP BY itemNumber, title, cout, cin, itemType, deweyClass\n')


if __name__ == '__main__':
    main(str(sys.argv[1]))
