void ring(int i, int d) {
    pushMatrix();
    translate(0, 0, d);
    // draw rings
    strokeWeight(3);
    stroke(RING_COLOR);
    noFill();
    circle(0, 0, RING_RADIUS * 2);
    // draw year text
    fill(FONT_COLOR);
    textSize(YEAR_SIZE);
    float angle = theta * i;
    setTextAlign(angle);
    text(String.valueOf(i + START_YEAR), RING_RADIUS * cos(angle), RING_RADIUS * sin(angle));
    // draw month text
    for (int j = 0; j < 12; j++) {
        textSize(MONTH_SIZE);
        float monthAngle = (2 * PI) / 12 * j;
        setTextAlign(monthAngle);
        text(MONTHS[j], RING_RADIUS * cos(monthAngle), RING_RADIUS * sin(monthAngle));
    }
    popMatrix();
}

void hud() {
    hint(DISABLE_DEPTH_TEST);
    cam.beginHUD();
    // draw title
    textSize(TITLE_SIZE);
    textAlign(LEFT, TOP);
    fill(FONT_COLOR);
    text("MOST POPULAR ITEMS BY CHECHOUTS 2006-2018\n IN SEATTLE PUBLIC LIBRARY", 15, 15);
    // draw legend

    cp5.draw();
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
}
